﻿using System;

namespace Aggregator.Aggregation.CarreApi
{
	public class ApiRequest
	{
		public BiometricHealthDataType BiometricHealthDataType { get; private set; }
		public DiagnosisHealthDataType DiagnosisHealthDataType { get; private set; }

		public RequestType Type { get; set; }

		public string Value { get; private set; }

		public DateTime Date { get; private set; }

		public ApiRequest(BiometricHealthDataType type, string value, DateTime date)
		{
			if (value == null || date == null)
			{
				throw new ArgumentException("Null parameter");	
			}

			BiometricHealthDataType = type;
			Value = value;
			Date = date;
			Type = RequestType.Biometric;
		}

		public ApiRequest(DiagnosisHealthDataType type, string value, DateTime date)
		{
			if (value == null || date == null) {
				throw new ArgumentException("Null parameter");
			}

			DiagnosisHealthDataType = type;
			Value = value;
			Date = date;
			Type = RequestType.Diagnosis;
		}
	}

	public enum RequestType
	{
		Biometric, Diagnosis
	}
}