﻿using System;
using Aggregator.Persistence;
using Aggregator.Persistence.Entities;
using Microsoft.Health.PatientConnect;

namespace Aggregator.Aggregation.PublicHealthRepositoryApi.Clients.HealthVault
{
	public class HealthVaultConnector
	{
		private readonly AggregatorDbContext _database;

		public HealthVaultConnector()
		{
			_database = new AggregatorDbContext();
		}

		public string CreatePatientConnection(string question, string answer, string carreToken)
		{
		    var connection = OfflineWebAppConnectionFactory.GetConnection(Guid.Empty);
            connection.Authenticate();

			string code = PatientConnection.Create(
                connection, "Carre", question, answer, new Uri("https://phr.carre-project.eu:442/json/oneway/HealthVaultCallbackRequest"), carreToken);
			return code;
		}

		public void AddPatient(string patientId, string carreToken)
		{
			_database.RegisteredPublicHealthRepositoryTokens.Add(new RegisteredPublicHealthRepositoryToken
			{
				CarreToken = carreToken,
				PublicHealthRepository = PublicHealthRepository.HealthVault,
				PublicHealthRepositoryToken = patientId,
				RegistrationTime = DateTime.Now	
			});
		}
	}
}