﻿using System;
using System.Web;
using Aggregator.Services.PhrRegistration;
using Funq;
using ServiceStack;
using ServiceStack.Logging;
using ServiceStack.Logging.Log4Net;

namespace Aggregator
{
	public class Global : HttpApplication
	{
		public class AppHost : AppHostBase
		{
			//Tell ServiceStack the name of your application and where to find your services
			public AppHost() : base("Token Registration Services", typeof(PhrRegistrationInitiationService).Assembly) { }

			public override void Configure(Container container)
			{
				//Plugins.Add(new CorsFeature());
				//register any dependencies your services use, e.g:
				//container.Register<ICacheClient>(new MemoryCacheClient());
			}
		}

		protected void Application_Start(object sender, EventArgs e)
		{
			new AppHost().Init();
			LogManager.LogFactory = new Log4NetFactory(configureLog4Net:true);
			ILog log = LogManager.GetLogger(GetType());
			log.Warn("Application started");
		}

		protected void Session_Start(object sender, EventArgs e)
		{

		}

		protected void Application_BeginRequest(object sender, EventArgs e)
		{

		}

		protected void Application_AuthenticateRequest(object sender, EventArgs e)
		{

		}

		protected void Application_Error(object sender, EventArgs e)
		{

		}

		protected void Session_End(object sender, EventArgs e)
		{

		}

		protected void Application_End(object sender, EventArgs e)
		{

		}
	}
}