﻿using System.ComponentModel.DataAnnotations.Schema;
using System.Data.Entity;
using Aggregator.Persistence.Entities;

namespace Aggregator.Persistence
{
	public class AggregatorDbContext : DbContext
	{
		public AggregatorDbContext() : base("name=pollux")
		{
		}

		public DbSet<RegisteredPublicHealthRepositoryToken> RegisteredPublicHealthRepositoryTokens { get; set; }

		public DbSet<AggregatedDataRecord> AggregatedDataRecords { get; set; }

		public DbSet<HealthVaultPatientConnection> HealthVaultPatientConnections { get; set; }

		protected override void OnModelCreating(DbModelBuilder modelBuilder)
		{
			var registeredPhrTokensConfig = modelBuilder.Entity<RegisteredPublicHealthRepositoryToken>();

			registeredPhrTokensConfig.HasKey(m => m.Id);
			registeredPhrTokensConfig.Property(m => m.Id).HasDatabaseGeneratedOption(DatabaseGeneratedOption.Identity);

			var aggregatedDataRecordsConfig = modelBuilder.Entity<AggregatedDataRecord>();

			aggregatedDataRecordsConfig.HasKey(m => m.Id);
			aggregatedDataRecordsConfig.Property(m => m.Id).HasDatabaseGeneratedOption(DatabaseGeneratedOption.Identity);

			var healthVaultPatientConnectionConfig = modelBuilder.Entity<HealthVaultPatientConnection>();

			healthVaultPatientConnectionConfig.HasKey(m => m.Id);
			healthVaultPatientConnectionConfig.Property(m => m.Id).HasDatabaseGeneratedOption(DatabaseGeneratedOption.Identity);

			base.OnModelCreating(modelBuilder);
		}
	}
}