﻿using System.Net;
using System.Net.Http;
using Aggregator.Aggregation;
using ServiceStack;

namespace Aggregator.Services.Aggregator
{
    public class AggregatorService : Service
    {
        public object Post(AggreationRequest request)
        {
	        try
	        {
		        if (AggregationLock.Locked)
			        return new HttpResponseMessage(HttpStatusCode.Conflict);

		        AggregationLock.Locked = true;
		        var service = new PublicHealthRepositoryDataAggregator();

		        service.Aggregate();

		        AggregationLock.Locked = false;
		        return new HttpResponseMessage(HttpStatusCode.OK);
	        }
	        finally
	        {
				AggregationLock.Locked = false;    
	        }
        }
    }
}